/*
><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

  Display Yin-Yang and Cartesian grid

 - Code distribution: 2013.09.14

 - I hope this code is helpful for your study.

 - Please do not remove my comments.

 - Please send me your feedback to:
              Hiroshi Hayashi
*/
/*
><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
<><><><><>
 obj.cpp
             2013.08.08: Created by Hiroshi Hayashi
><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
*/
#include "obj.hpp"
#include<cstdio>
#include<cmath>
void object::init(){
  obj = gluNewQuadric();
  gluQuadricDrawStyle(obj,GLU_FILL);
}

void object::drawClynder(double start[],double end[],double radius){
#define EQ(a,b) (fabs(b-a) < 1e-3)
    float vx = end[0] - start[0];
    float vy = end[1] - start[1]; 
    float vz = end[2] - start[2];
    double dist = sqrt(vx*vx + vy*vy + vz*vz);
    double theta = vz/dist;
    if(EQ(theta ,1.0)){
            theta = 1.0;               
    }else if(EQ(theta ,-1.0)){
            theta = -1.0;
    }
    float rad = acos(theta);
    glPushMatrix();
    {
        glTranslated(start[0], start[1], start[2]);

        if(EQ(vx,0.0) && EQ(vy,0.0)){
                glRotated(rad*180.0/M_PI, 0.0, -1.0, 0.0);
//
// Modified as a check 130808
//              gluCylinder(obj,radius,radius,dist,10,10);
                gluCylinder(obj,radius,radius,dist,3,3);
        }else{
        glRotated(rad*180/M_PI, -vy, vx, 0.0);
//
// Modified as a check 130808
//      gluCylinder(obj,radius,radius,dist,10,10);
        gluCylinder(obj,radius,radius,dist,3,3);
        }
    }
    glPopMatrix();
}
